# coding: utf-8

"""
    Package Repository Service

    Manages a repository of packages  # noqa: E501

    The version of the OpenAPI document: 1
    Contact: support@ni.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from systemlink.clients.nirepo.configuration import Configuration


class StoreItemInstallerRepositories(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'package_name': 'str',
        'file': 'str',
        'md5_checksum': 'str',
        'repository_path': 'str',
        'feed_type': 'str'
    }

    attribute_map = {
        'package_name': 'packageName',
        'file': 'file',
        'md5_checksum': 'md5Checksum',
        'repository_path': 'repositoryPath',
        'feed_type': 'feedType'
    }

    def __init__(self, package_name=None, file=None, md5_checksum=None, repository_path=None, feed_type=None, local_vars_configuration=None):  # noqa: E501
        """StoreItemInstallerRepositories - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._package_name = None
        self._file = None
        self._md5_checksum = None
        self._repository_path = None
        self._feed_type = None
        self.discriminator = None

        if package_name is not None:
            self.package_name = package_name
        if file is not None:
            self.file = file
        if md5_checksum is not None:
            self.md5_checksum = md5_checksum
        if repository_path is not None:
            self.repository_path = repository_path
        if feed_type is not None:
            self.feed_type = feed_type

    @property
    def package_name(self):
        """Gets the package_name of this StoreItemInstallerRepositories.  # noqa: E501

        The name of one of the packages.  # noqa: E501

        :return: The package_name of this StoreItemInstallerRepositories.  # noqa: E501
        :rtype: str
        """
        return self._package_name

    @package_name.setter
    def package_name(self, package_name):
        """Sets the package_name of this StoreItemInstallerRepositories.

        The name of one of the packages.  # noqa: E501

        :param package_name: The package_name of this StoreItemInstallerRepositories.  # noqa: E501
        :type: str
        """

        self._package_name = package_name

    @property
    def file(self):
        """Gets the file of this StoreItemInstallerRepositories.  # noqa: E501

        The location of the file, including the file extension. Depending on the platform you select, you will be able to use the following package extensions: .nipkg for windows feeds, .ipk and .deb for ni-linux-rt feeds.   # noqa: E501

        :return: The file of this StoreItemInstallerRepositories.  # noqa: E501
        :rtype: str
        """
        return self._file

    @file.setter
    def file(self, file):
        """Sets the file of this StoreItemInstallerRepositories.

        The location of the file, including the file extension. Depending on the platform you select, you will be able to use the following package extensions: .nipkg for windows feeds, .ipk and .deb for ni-linux-rt feeds.   # noqa: E501

        :param file: The file of this StoreItemInstallerRepositories.  # noqa: E501
        :type: str
        """

        self._file = file

    @property
    def md5_checksum(self):
        """Gets the md5_checksum of this StoreItemInstallerRepositories.  # noqa: E501

        The MD5 fingerprint of the file.  # noqa: E501

        :return: The md5_checksum of this StoreItemInstallerRepositories.  # noqa: E501
        :rtype: str
        """
        return self._md5_checksum

    @md5_checksum.setter
    def md5_checksum(self, md5_checksum):
        """Sets the md5_checksum of this StoreItemInstallerRepositories.

        The MD5 fingerprint of the file.  # noqa: E501

        :param md5_checksum: The md5_checksum of this StoreItemInstallerRepositories.  # noqa: E501
        :type: str
        """

        self._md5_checksum = md5_checksum

    @property
    def repository_path(self):
        """Gets the repository_path of this StoreItemInstallerRepositories.  # noqa: E501

        The path to the repository where the package is found.  # noqa: E501

        :return: The repository_path of this StoreItemInstallerRepositories.  # noqa: E501
        :rtype: str
        """
        return self._repository_path

    @repository_path.setter
    def repository_path(self, repository_path):
        """Sets the repository_path of this StoreItemInstallerRepositories.

        The path to the repository where the package is found.  # noqa: E501

        :param repository_path: The repository_path of this StoreItemInstallerRepositories.  # noqa: E501
        :type: str
        """

        self._repository_path = repository_path

    @property
    def feed_type(self):
        """Gets the feed_type of this StoreItemInstallerRepositories.  # noqa: E501

        The release type of the feed.  # noqa: E501

        :return: The feed_type of this StoreItemInstallerRepositories.  # noqa: E501
        :rtype: str
        """
        return self._feed_type

    @feed_type.setter
    def feed_type(self, feed_type):
        """Sets the feed_type of this StoreItemInstallerRepositories.

        The release type of the feed.  # noqa: E501

        :param feed_type: The feed_type of this StoreItemInstallerRepositories.  # noqa: E501
        :type: str
        """
        allowed_values = ["RELEASED", "RELEASED-CRITICAL"]  # noqa: E501
        if self.local_vars_configuration.client_side_validation and feed_type not in allowed_values:  # noqa: E501
            raise ValueError(
                "Invalid value for `feed_type` ({0}), must be one of {1}"  # noqa: E501
                .format(feed_type, allowed_values)
            )

        self._feed_type = feed_type

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, StoreItemInstallerRepositories):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, StoreItemInstallerRepositories):
            return True

        return self.to_dict() != other.to_dict()
